#include <Stepper.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <Adafruit_NeoPixel.h>

Stepper moteur_PaP(2048, 9, 11, 10, 8);
LiquidCrystal_I2C lcd(0x3F, 16, 2);
Adafruit_NeoPixel pixels_led_avant = Adafruit_NeoPixel(11, 6, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel pixels_led_arriere = Adafruit_NeoPixel(12, 7, NEO_GRB + NEO_KHZ800);

int Jour;
int mois;
int annee;
int etatclock;
int newetatclock;
int etatdt;
int newtatdt;
int etatsw;
int newetatsw;
int modificationdate;
unsigned long lastmouv;
int nbmouv;
unsigned long heure_led_on;
unsigned long heure_led_off;
int i;
int t;
int j;
int h;
int nombreDePasParTour_moteur_PaP = 2048;

// Décrire cette fonction
void AffichageDate() {
  if (Jour < 10) {
    lcd.setCursor(3,0);
    lcd.print("0");
    lcd.setCursor(4,0);
    lcd.print(Jour);

  } else {
    lcd.setCursor(3,0);
    lcd.print(Jour);

  }
  lcd.setCursor(5,0);
  lcd.print("/");
  if (mois < 10) {
    lcd.setCursor(6,0);
    lcd.print("0");
    lcd.setCursor(7,0);
    lcd.print(mois);

  } else {
    lcd.setCursor(6,0);
    lcd.print(mois);

  }
  lcd.setCursor(8,0);
  lcd.print("/     ");
  lcd.setCursor(9,0);
  lcd.print(annee);
}


// Décrire cette fonction
void convecteur_temporel() {
  lcd.setCursor(1,1);
  lcd.print("2.21 Gigowatts!");
  for (i = 40; i >= 1; i=i-1) {
    tone(5,(4100 - i * 100));
    led_etat_1();
    moteur_PaP.step((i * -1));
    led_eteinte();
    moteur_PaP.step((i * -1));
  }
  delay(500);
  for (i = 1; i <= 40; i=i+1) {
    tone(5,(4100 - i * 100));
    led_eteinte();
    moteur_PaP.step(i);
    led_etat_1();
    moteur_PaP.step(i);
  }
  noTone(5);
  lcd.setCursor(1,1);
  lcd.print("                        ");
}


// Décrire cette fonction
void changedate(unsigned int j) {
  Serial.print("changedate : delta=");
   Serial.println(j);
  if (modificationdate == 1) {
    Jour = Jour + j;
    if (Jour >= 32) {
      Jour = 1;

    } else if (Jour <= 0) {
      Jour = 31;
    }
    Serial.print("changedate : jour=");
     Serial.println(Jour);

  } else if (modificationdate == 2) {
    mois = mois + j;
    if (mois >= 13) {
      mois = 1;

    } else if (mois <= 0) {
      mois = 12;
    }
    Serial.print("changedate : mos=");
     Serial.println(mois);
  } else if (modificationdate == 3) {
    annee = annee + j;
  }
  AffichageDate();
}


// Décrire cette fonction
void led_etat_1() {
  for (t = 2; t <= 6; t=t+1) {
    pixels_led_avant.setPixelColor(t, pixels_led_avant.Color(100,100,100));
    pixels_led_avant.show();
  }
  pixels_led_avant.setPixelColor(1, pixels_led_avant.Color(58,142,186));
  pixels_led_avant.show();
  pixels_led_avant.setPixelColor(7, pixels_led_avant.Color(58,142,186));
  pixels_led_avant.show();
  for (j = 8; j <= 10; j=j+1) {
    pixels_led_avant.setPixelColor(j, pixels_led_avant.Color(100,100,100));
    pixels_led_avant.show();
  }
  for (h = 2; h <= 5; h=h+1) {
    pixels_led_arriere.setPixelColor(h, pixels_led_arriere.Color(150,0,0));
    pixels_led_arriere.show();
  }
  pixels_led_arriere.setPixelColor(1, pixels_led_arriere.Color(58,142,186));
  pixels_led_arriere.show();
  pixels_led_arriere.setPixelColor(6, pixels_led_arriere.Color(58,142,186));
  pixels_led_arriere.show();
  pixels_led_arriere.setPixelColor(8, pixels_led_arriere.Color(100,100,0));
  pixels_led_arriere.show();
  pixels_led_arriere.setPixelColor(10, pixels_led_arriere.Color(100,100,0));
  pixels_led_arriere.show();
  pixels_led_arriere.setPixelColor(11, pixels_led_arriere.Color(100,100,0));
  pixels_led_arriere.show();
}


// Décrire cette fonction
void led_eteinte() {
  for (t = 0; t <= 10; t=t+1) {
    pixels_led_avant.setPixelColor(t, pixels_led_avant.Color(0,0,0));
    pixels_led_avant.show();
  }
  for (h = 0; h <= 11; h=h+1) {
    pixels_led_arriere.setPixelColor(h, pixels_led_arriere.Color(0,0,0));
    pixels_led_arriere.show();
  }
}


// Décrire cette fonction
void led_etat_0() {
  for (t = 2; t <= 6; t=t+1) {
    pixels_led_avant.setPixelColor(t, pixels_led_avant.Color(100,100,100));
    pixels_led_avant.show();
  }
  pixels_led_avant.setPixelColor(1, pixels_led_avant.Color(58,142,186));
  pixels_led_avant.show();
  pixels_led_avant.setPixelColor(7, pixels_led_avant.Color(58,142,186));
  pixels_led_avant.show();
  for (j = 8; j <= 10; j=j+1) {
    pixels_led_avant.setPixelColor(j, pixels_led_avant.Color(100,100,100));
    pixels_led_avant.show();
  }
  for (h = 2; h <= 5; h=h+1) {
    pixels_led_arriere.setPixelColor(h, pixels_led_arriere.Color(150,0,0));
    pixels_led_arriere.show();
  }
  pixels_led_arriere.setPixelColor(1, pixels_led_arriere.Color(58,142,186));
  pixels_led_arriere.show();
  pixels_led_arriere.setPixelColor(6, pixels_led_arriere.Color(58,142,186));
  pixels_led_arriere.show();
  pixels_led_arriere.setPixelColor(8, pixels_led_arriere.Color(100,100,0));
  pixels_led_arriere.show();
  pixels_led_arriere.setPixelColor(10, pixels_led_arriere.Color(100,100,0));
  pixels_led_arriere.show();
  pixels_led_arriere.setPixelColor(11, pixels_led_arriere.Color(100,100,0));
  pixels_led_arriere.show();
}



void setup() {
  moteur_PaP.setSpeed(5);
  lcd.init();
  lcd.backlight();
  lcd.noCursor();
  lcd.noBlink();

  pinMode(6, OUTPUT);
  pixels_led_avant.begin();
  pinMode(7, OUTPUT);
  pixels_led_arriere.begin();
  Serial.begin(115200);
    lcd.setCursor(1,0);
  lcd.print("Nom de Zeus !");
  led_etat_0();
  delay(5000);
  lcd.clear();
  Jour = 3;
  mois = 7;
  annee = 1985;
  etatclock = 0;
  newetatclock = 0;
  etatdt = 0;
  newtatdt = 0;
  etatsw = 0;
  newetatsw = 0;
  modificationdate = 0;
  lastmouv = (unsigned long)(0);
  nbmouv = 1;
  heure_led_on = (unsigned long)(0);
  heure_led_off = (unsigned long)(0);
  AffichageDate();

  pinMode(5, OUTPUT);
  pinMode(4, INPUT);
  pinMode(2, INPUT);
  pinMode(3, INPUT);
}

void loop() {
  newetatsw = digitalRead(4);
  newetatclock = digitalRead(2);
  newtatdt = digitalRead(3);
  if (newetatsw == 0 && etatsw == 1) {
    modificationdate = modificationdate + 1;
    heure_led_on = millis() + 20;
    Serial.print("bouton appuyé mod date=");
     Serial.println(modificationdate);
    if (modificationdate == 4) {
      convecteur_temporel();
      modificationdate = 0;

    }

  }
  if (millis() >= heure_led_on) {
    led_etat_1();
    heure_led_off = millis() + 500;
    heure_led_on = millis() + 1000;

  }
  if (millis() >= heure_led_off) {
    led_eteinte();
    heure_led_on = millis() + 500;
    heure_led_off = millis() + 1000;

  }
  if (newetatclock != etatclock) {
    Serial.print("clock=");
     Serial.println(newetatclock);
    if (newetatclock == 0) {
      delay(5);
      if (millis() > lastmouv) {
        nbmouv = 1;

      } else {
        nbmouv = nbmouv + 1;

      }
      lastmouv = millis() + 200;
      if (newtatdt == 0) {
        changedate(nbmouv * -1);

      } else {
        changedate(nbmouv * 1);

      }

    }

  }
  etatdt = newtatdt;
  etatclock = newetatclock;
  etatsw = newetatsw;

}
